const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

    let x,y,y1,n;
	let v;
	let dv;
	let av;
	let f;
	let r,r1;
	let t,l;
	let dt;
	let fl1,fl2,fl3;
	let d = { width: canvas.width, height: canvas.height };

function init() {
	    fl1=0;
		fl2=0;
		fl3=0;
		v=0;
		f=1;
		n=2;
		av=0.0008;	
		dv=0;
		t=10;
		dt=5;
		r=4;
		r1=6;
		l=420;
		
		buffer = createBuffer(d.width, d.height);
        drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");//////////////////////////////
	    g.fillStyle = "white";
        g.fillRect(0, 0, d.width, d.height);
		
		g.fillStyle = "black";
		g.fillRect(61,60,l-4,5);//気柱　横棒1
		g.fillRect(61,65+10*r1+2,l-4,5);//2
		g.fillRect(61,240-5*r1-6,l-4,5);//3
		g.fillRect(61,240+5*r1+1,l-4,5);//4
		g.fillRect(61,420-5,l-4,5);//6
		g.fillRect(61,415-10*r1-7,l-4,5);//5
		
		g.strokeStyle = "black";
		g.beginPath();
        g.moveTo(61,50);
        g.lineTo(60+l-4,50);
        g.moveTo(61,65+10*r1+2+15);
        g.lineTo(60+l-4,65+10*r1+2+15);
		g.moveTo(61,240+5*r1+1+15);
        g.lineTo(60+l/2-2,240+5*r1+1+15);
		
        g.moveTo(61+l/2-1,240+5*r1+1+15);//
        g.lineTo(60+l-4,240+5*r1+1+15);
		g.moveTo(61,420+10);//
        g.lineTo(60+l/3-1,420+10);
		
		g.moveTo(61+l/3,420+10);//
        g.lineTo(60+2*l/3,420+10);
		g.moveTo(62+2*l/3,420+10);//
        g.lineTo(60+l-4,420+10);
		
		g.moveTo(60+l-4,50);//矢印
        g.lineTo(60+l-4-10,50-6);
		g.moveTo(61,50);//矢印
        g.lineTo(61+10,50+6);
		
		g.moveTo(60+l-4,50);//矢印
        g.lineTo(60+l-4-10,50+6);
		g.moveTo(61,65+10*r1+2+15);//矢印
        g.lineTo(61+10,65+10*r1+2+15-6);
		
		g.moveTo(61,65+10*r1+2+15);//矢印
        g.lineTo(61+10,65+10*r1+2+15+6);
		g.moveTo(60+l-4,65+10*r1+2+15);//矢印
        g.lineTo(60+l-4-10,65+10*r1+2+15-6);
		
		g.moveTo(60+l-4,65+10*r1+2+15);//矢印
        g.lineTo(60+l-4-10,65+10*r1+2+15+6);
		g.moveTo(61,240+5*r1+1+15);//矢印
        g.lineTo(61+10,240+5*r1+1+15-6);

		
		
		g.moveTo(61,240+5*r1+1+15);
        g.lineTo(61+10,240+5*r1+1+15+6);
        g.moveTo(60+l/2-2,240+5*r1+1+15);
        g.lineTo(60+l/2-2-10,240+5*r1+1+15-6);
		g.moveTo(60+l/2-2,240+5*r1+1+15);
        g.lineTo(60+l/2-2-10,240+5*r1+1+15+6);
		
        g.moveTo(61+l/2-1,240+5*r1+1+15);//
        g.lineTo(61+l/2-1+10,240+5*r1+1+15-6);
		g.moveTo(61+l/2-1,240+5*r1+1+15);//
        g.lineTo(61+l/2-1+10,240+5*r1+1+15+6);
		
		g.moveTo(60+l-4,240+5*r1+1+15);//
        g.lineTo(60+l-4-10,240+5*r1+1+15-6);
		g.moveTo(60+l-4,240+5*r1+1+15);//
        g.lineTo(60+l-4-10,240+5*r1+1+15+6);
		
		g.moveTo(61,420+10);//矢印
        g.lineTo(61+10,420+10-6);
		g.moveTo(61,420+10);//矢印
        g.lineTo(61+10,420+10+6);
		
		g.moveTo(60+l/3-1,420+10);//矢印
        g.lineTo(60+l/3-1-10,420+10-6);
		g.moveTo(60+l/3-1,420+10);//矢印
        g.lineTo(60+l/3-1-10,420+10+6);
		
		g.moveTo(61+l/3,420+10);//矢印
        g.lineTo(61+l/3+10,420+10-6);
		g.moveTo(61+l/3,420+10);//矢印
        g.lineTo(61+l/3+10,420+10+6);
		
		g.moveTo(60+2*l/3,420+10);//矢印
        g.lineTo(60+2*l/3-10,420+10-6);
		g.moveTo(60+2*l/3,420+10);//矢印
        g.lineTo(60+2*l/3-10,420+10+6);	
		g.moveTo(62+2*l/3,420+10);//矢印
        g.lineTo(62+2*l/3+10,420+10-6);
		g.moveTo(62+2*l/3,420+10);//矢印
        g.lineTo(62+2*l/3+10,420+10+6);
        g.moveTo(60+l-4,420+10);//矢印
        g.lineTo(60+l-4-10,420+10-6);
		g.moveTo(60+l-4,420+10);//矢印
        g.lineTo(60+l-4-10,420+10+6);					
        g.stroke();
		
        g.fillStyle="blue";
		g.fillText("L",60+l/2-3,45);
		g.fillText("(1/2)λ",60+l/2-10,65+10*r1+2+15+15);//1
		g.fillText("(1/2)λ",60+l/4-10,240+5*r1+1+15+15);//2
		g.fillText("(1/2)λ",60+3*l/4-10,240+5*r1+1+15+15);
		g.fillText("(1/2)λ",60+l/6-10,420+10+15);//3
		g.fillText("(1/2)λ",60+l/2-10,420+10+15);
		g.fillText("(1/2)λ",60+5*l/6-10,420+10+15);

		g.fillText("BasicVibration",60+l+60,63+5*r1);//1
		g.fillText("(1/2)λ=L , λ=2L , f=V/2L",60+l+60,65+10*r1+2+10);
		g.fillText("DoubleVibration",60+l+60,238);//2
		g.fillText("(1/2)λ×2=L , λ=2L/2 , f=2V/2L",60+l+60,240+5*r1+1+10);
		g.fillText("TripleVibration",60+l+60,412-5*r1);//3
		g.fillText("(1/2)λ×3=L , λ=2L/3 , f=3V/2L",60+l+60,425);
		g.fill();


       for (x=0;x<=2*l;x=x+2*r1){
			y=Math.sin(50*v)*100*Math.sin(x*2*3.14159/(2*l))+x;	
		for (y1=0;y1<=4;y1=y1+1){
		if(y>=l/2&&y<=3*l/2){
			g.fillStyle="red";
			g.beginPath();	
			g.arc(y-l/2+60,65+y1*2*r1+3+r1/2,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
	   }
	   
		for (x=0;x<=2*l;x=x+2*r1){
		
		y=Math.sin(50*2*v)*60*Math.sin(x*2*Math.PI/l)+x;	
		for (y1=0;y1<=4;y1=y1+1){
		if(y>=l/4&&y<=5*l/4){
			g.fillStyle="red";
			g.beginPath();	
			g.arc(y-l/4+60,240-5*r1+y1*2*r1+3+r1/2,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
		}
		
		for (x=0;x<=2*l;x=x+2*r1){
			y=Math.sin(50*3*v)*30*Math.sin(x*2*3*Math.PI/(2*l))+x;	
		for (y1=0;y1<=4;y1=y1+1){
		if(y>=l/6&&y<=7*l/6){
			g.fillStyle="red";
			g.beginPath();	
			g.arc(y-l/6+60,415-10*r1+y1*2*r1+2+r1/2,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
        }
		
			if(fl2==1){
			for (x=0;x<=2*l;x=x+r){
			y=-Math.sin(50*v)*25*Math.sin(x*2*Math.PI/(2*l))+63+5*r1;
			if(x>=l/2&&x<=3*l/2){
				g.fillStyle="blue";
				g.beginPath();	
			    g.arc(x-l/2+55+r1/2,y+r1/2,r/2, 0, Math.PI * 2);
			    g.fill();
				}
			}

			for (x=0;x<=2*l;x=x+r){
			y=-Math.sin(50*2*v)*25*Math.sin(x*2*Math.PI/l)+238;
			if(x>=l/4&&x<=5*l/4){
				g.fillStyle="blue";
				g.beginPath();	
			    g.arc(x-l/4+55+r1/2,y+r1/2,r/2, 0, Math.PI * 2);
			    g.fill();
			}
			}			
			
			for (x=0;x<=2*l;x=x+r){
			y=-Math.sin(50*3*v)*25*Math.sin(x*2*3*Math.PI/(2*l))+412-5*r1;
			if(x>=l/6&&x<=7*l/6){
				g.fillStyle="blue";
				g.beginPath();	
			    g.arc(x-l/6+55+r1/2,y+r1/2,r/2, 0, Math.PI * 2);
			    g.fill();
				}
			}			
            }
}


function move() {
    dv=fl1*av;
		v=v+dv;
		t=t+dt;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
}

document.getElementById('dp').addEventListener('click', dp);
document.getElementById('ndp').addEventListener('click', ndp);
document.getElementById('run').addEventListener('click', run);
document.getElementById('stop').addEventListener('click', stop);
document.getElementById('sbs').addEventListener('click', sbs);
document.getElementById('reset').addEventListener('click', reset);

function dp() {//横波表示
        fl2=1;
}
function ndp() {//非表示
        fl2=0;
}
function run() {
        fl1=1;
}
function stop() {
        fl1=0;dv=0;
}
function sbs() {//コマ送り
        fl1=0;v=v+0.5;
}
function reset() {
       fl1=0;v=0;dv=0;y=0;
}


init();
start();